;******************* Libraries **********************
	include	"hexlib.h"
	include	"tios.h"
	include	"kernel.h"
	include	"flib.h"

COUNT	EQU	4

InterruptOFF	MACRO
	move.w	#$700,d0	;disable the
	trap	#1		;interrupt
	move.w	d0,-(a7)	;save old sr
	ENDM

InterruptON	MACRO
	move.w	(a7)+,d0	;restore old sr 
	trap	#1		;to enable interrupt
	ENDM

;************** Start of Fargo program ***************
	xdef	_main
	xdef	_comment

_main	jsr	flib::clr_scr

	clr.w	nbthread	;2 thread
	clr.w	curthread	;current : 0
	

	clr.l	cpt
	move.w	#COUNT,cpt2
	
	move.l	a7,old_stack

	bsr	init_interrupt

	lea	prg1(PC),a1
	bsr	CreateThread

	lea	prg2(PC),a1
	bsr	CreateThread
	

\Wait	addq.l	#1,cpt
	move.l	cpt,d0
	move.l	#9,d1
	move.l	#9,d2
	move.l	#5,d4
	jsr	hexlib::put_hex

	tst.w	nbthread
	bne	\Wait

\out
	bsr	restore_interrupt

	move.l	old_stack,a7
\exit	rts

init_interrupt:
	move.w	#$0700,d0
	trap	#1
	move.l	$64,old_int_1
	bclr.b	#2,$600001
	move.l	#int_1,$64
	bset.b	#2,$600001
	trap	#1
	rts

restore_interrupt:
	move.w	#$0700,d0
	trap	#1
	bclr.b	#2,$600001
	move.l	old_int_1,$64
	bset.b	#2,$600001
	trap	#1
	rts


int_1:
	sub.w	#1,cpt2
	tst.w	(cpt2)
	bne	\skip1
	move.w	#COUNT,cpt2
	
	move.l	a0,-(a7)	;save a0 because we change it

	move.l	usp,a0		;a0 is current user stack
	
	move.l	(a7)+,-(a0)	;put saved a0
	movem.l	d0-d7/a1-a6,-(a0)
	move.l	2(a7),-(a0)	;return addr
	move.w	(a7),-(a0)	;sr addr	

	move.w	curthread,d0	;current thread
	move.w	d0,d1		;save d0
	lea	Threads(PC),a1
	move.l	a1,a2		;save a1
	lsl.w	#2,d1		;d0*4
	move.l	a0,0(a1,d1.w)	;save the stack addr

	addq.w	#1,d0		;curthread+=1
	cmp.w	nbthread,d0
	bls	\noloop
	clr.w	d0
\noloop	move.w	d0,curthread
	move.l	a2,a0
	lsl.w	#2,d0		;d0*4
	move.l	0(a0,d0.w),a0	;addr of thread user stack

	move.l	a0,a1
	adda.w	#66,a1		;Am I sure ?
	move.l	a1,usp		;Put the new user stack addr

	move.w	(a0)+,(a7)	;put sr
	move.l	(a0)+,2(a7)	;and return addr
	movem.l	(a0)+,d0-d7/a1-a6
	move.l	(a0)+,a0

\skip1	move.l	old_int_1,-(a7)	;call the
	rts			;old routine

;--------------------------------------------------
; a1 : file name
CreateThread:
	InterruptOFF

	move.l	a1,-(a7)
	move.w	#$0C,-(a7)
	jsr	tios::FindSymEntry
	addq.l	#6,a7
	move.l	a0,d0
	tst.l	d0
	beq	\exit

	move.w	10(a0),d0	;handle of file
	move.w	d0,d5		;save hdl of file

	move.l	#3500,-(a7)	;3500 bytes for the stack
	jsr	tios::HeapAlloc	;alloc the buffer
	addq.l	#4,a7
	tst.l	d0		;was OK ?
	beq	\exit		;if not, exit
	move.w	d0,d1		;save the handle
	tios::DEREF d0,a0	;get the address
	adda.w	#3500,a0	;go to the end of the stack
	move.w	d1,-(a0)	;and put on this stack the hdl of the stack

	add.w	#1,nbthread
	move.w	nbthread,d1
	lea	Threads(PC),a1
	lsl.w	#2,d1
	adda.w	d1,a1

	move.w	d5,-(a0)	;put hdl of file
	move.l	a0,-(a0)	;first put a0
	movem.l	d0-d7/a1-a6,-(a0) ;then other registers
	move.l	#RunProg,-(a0)	;addr to go
	move.w	(a7),-(a0)	;the sr register pushed on the stack
	move.l	a0,(a1)		;put the stack addr
	
\exit	InterruptON

	rts

;-----------------------------------------------
; >>intern function<<
;-----------------------------------------------
RunProg:
	jsr	kernel::exec	;hdl already on the stack
	addq.l	#2,a7

	move.w	#$700,d0	;disable the
	trap	#1		;interrupt
	
				;hdl of the stack buffer is already on the satck
	jsr	tios::HeapFree
	;addq.l	#2,a7		;useless

	subq.w	#1,nbthread
	move.w	nbthread,d3
	move.w	curthread,d0
	cmp.w	d0,d3
	bcs	\nochg
	sub.w	d0,d3
	lea	Threads(PC),a0
	lsl.w	#2,d0
	adda.w	d0,a0

\cpy	move.l	4(a0),(a0)
	addq.l	#4,a0
	dbra	d3,\cpy

	move.w	curthread,d0
	bra	\noloop

	;move.w	curthread,d0
	;addq.w	#1,d0		;curthread+=1
	;cmp.w	nbthread,d0
	;bls	\noloop
\nochg	clr.w	d0

\noloop	move.w	d0,curthread
	lea	Threads(PC),a0
	lsl.w	#2,d0		;d0*4
	move.l	0(a0,d0.w),a0	;addr of thread user stack

	move.l	a0,a1
	adda.w	#66,a1		;Am I sure ?
	move.l	a1,a7		;Put the new user stack addr

	move.w	#COUNT,cpt2

	move.w	(a0)+,d0	;put sr
	trap	#1		;enable interrupt & put right SR
	move.l	(a0)+,-(a7)	;and return addr
	movem.l	(a0)+,d0-d7/a1-a6
	move.l	(a0)+,a0
	
	rts


;*****************************************************
; Program data
;*****************************************************

old_int_1	dc.l	0

nbthread	dc.w	0
curthread	dc.w	0

old_stack	dc.l	0

;addrbuf		dc.l	0

	dcb.b	64,0
buf

Threads:
OSStAddr dc.l	0
ThStAddr dc.l	0
Th2StAddr dc.l	0

cpt	dc.l	0
cpt2	dc.w	0

prg1	dc.b	"multask1",0
prg2	dc.b	"multask2",0


_comment
	dc.b	"REAL MultiTasking KERNEL Ex",0


;*************** End of Fargo program ****************

	end
